//+------------------------------------------------------------------+
//|                                                      Expert1.mq5 |
//|                                  Copyright 2021, MetaQuotes Ltd. |
//|                                             https://www.mql5.com |
//+------------------------------------------------------------------+
#property copyright "Copyright 2021, MetaQuotes Ltd."
#property link      "https://www.mql5.com"
#property version   "1.00"
//---
#include <Trade\DealInfo.mqh>
//---
CDealInfo      m_deal;                       // object of CDealInfo class
//--- input parameters

//+------------------------------------------------------------------+
//| Expert initialization function                                   |
//+------------------------------------------------------------------+
int OnInit()
  {
//---
   return(INIT_SUCCEEDED);
  }
//+------------------------------------------------------------------+
//| Expert deinitialization function                                 |
//+------------------------------------------------------------------+
void OnDeinit(const int reason)
  {
//---
  }
//+------------------------------------------------------------------+
//| Expert tick function                                             |
//+------------------------------------------------------------------+
void OnTick()
  {
//---
  }
//+------------------------------------------------------------------+
//| TradeTransaction function                                        |
//+------------------------------------------------------------------+
void OnTradeTransaction(const MqlTradeTransaction &trans,
                        const MqlTradeRequest &request,
                        const MqlTradeResult &result)
  {
//--- get transaction type as enumeration value
   ENUM_TRADE_TRANSACTION_TYPE type=trans.type;
//--- if transaction is result of addition of the transaction in history
   if(type==TRADE_TRANSACTION_DEAL_ADD)
     {
      ResetLastError();
      if(HistoryDealSelect(trans.deal))
         m_deal.Ticket(trans.deal);
      else
        {
         Print(__FILE__," ",__FUNCTION__,", ERROR: ","HistoryDealSelect(",trans.deal,") error: ",GetLastError());
         return;
        }
      ENUM_DEAL_TYPE deal_type   = m_deal.DealType();
      ENUM_DEAL_ENTRY deal_entry = m_deal.Entry();
      if(deal_type==DEAL_TYPE_BUY || deal_type==DEAL_TYPE_SELL)
        {
         long deal_reason=-1;
         if(!m_deal.InfoInteger(DEAL_REASON,deal_reason))
           {
            Print(__FUNCTION__,", ERROR:  InfoInteger(DEAL_REASON ...");
            return;
           }
         if((ENUM_DEAL_REASON)deal_reason==DEAL_REASON_SL)
           {
            Print(__FUNCTION__,", DEAL_REASON_SL");
            return;
           }
         if((ENUM_DEAL_REASON)deal_reason==DEAL_REASON_TP)
           {
            Print(__FUNCTION__,", DEAL_REASON_TP");
            return;
           }
        }
     }
  }
//+------------------------------------------------------------------+
